//
// Base64Encoding.h
//

#pragma once

//
// class declaration
//

class Base64Encoding
{
public:

	//
	// public methods
	//

	static void encodeA( char* pszOutput, const char* pszInput ); // ### REMEMBER THE TERMINATING NULL CHARACTER THAT IS PUT BY THIS ROUTINE! ###
	static void encodeW( char* pszOutput, const WCHAR* pszInput ); // ### REMEMBER THE TERMINATING NULL CHARACTER THAT IS PUT BY THIS ROUTINE! ###

	static void decode( BYTE* pbOutput, char* pszInput, size_t sTerminatingChrs );

	static size_t required_chrsA( char* pszInput );
	static size_t required_chrsW( WCHAR* pszInput );

protected:

	//
	// protected functions
	//

	static void EncodeByteString( char* pszOutput, BYTE* pbInput, size_t sInputDim );
	static int Base64ChrToIndex( char cBase64Chr );
};
